'       Outlook
'    -  ClientsCount,   
'    -        
'  

Dim sUser 	'  ,   
Dim sDbPath	'     
Dim sDbFile	'   

Dim objArgs 	'  WScript.Arguments 
Dim objApp 	'  Outlook.Application
Dim objContacts '  Outlook.Items -  ""
Dim objItem     '  Outlook.ContactItem - 
Dim objWSH      '  WScript.Shell 

Dim objCon      '  ADODB.Connection
Dim objRs       '  ADODB.Recordset  
Dim objWs	'  ADODB.Recordset  
Dim sSql        '   

'  
Dim iCntImport  '    ClientsCount
Dim iCntExport  '    Outlook
Dim iCntSync    '  
Dim iCntTotal   '    ClientsCount
Dim iCntOutlook '    Outlook
Dim sMsg        '    
Dim lIn

'     outlook
Sub ClientsCount2Outlook(AFrom, ATo)
  ATo.Birthday = AFrom("BirthDate")
  ATo.JobTitle = AFrom("Title")
  ATo.BusinessAddressCountry = AFrom("Country")
  ATo.BusinessAddressCity = AFrom("City")
  ATo.MobileTelephoneNumber = AFrom("Phone")
  ATo.BusinessTelephoneNumber = AFrom("WorkPhone")
  ATo.Email1Address = AFrom("EMail")
  ATo.Email1DisplayName = AFrom("Contact")
  ATo.IMAddress = AFrom("ICQ")
  If IsNull(AFrom("ClientCalc").Value) Then
    ATo.FileAs = AFrom("Contact")
  Else
    ATo.CompanyName = AFrom("ClientCalc")
    ATo.FileAs = AFrom("Contact") & " (" & AFrom("ClientCalc") & ")"
  End If
  ATo.Save
End Sub

'     ClientsCount
Sub Outlook2ClientsCount(AFrom, ATo)
  ATo("BirthDate") = AFrom.Birthday
  ATo("Title") = AFrom.JobTitle
  ATo("Country") = AFrom.BusinessAddressCountry
  ATo("City") = AFrom.BusinessAddressCity
  ATo("Phone") = Replace(AFrom.MobileTelephoneNumber, " ", "")
  ATo("WorkPhone") = Replace(AFrom.BusinessTelephoneNumber, " ", "")
  ATo("EMail") = AFrom.Email1Address
  ATo("ICQ") = AFrom.IMAddress
  ATo("Notes") = "  Outlook"
  ATo.Update
End Sub

'   
Sub CheckFields(ByRef objClients, objOutlook)
  If objOutlook <> objClients.Value Then
    sMsg = sMsg & vbCrLf & " """ & objClients.Name & """ [" & objClients.Value & "]<>[" & objOutlook & "]"
  End If
End Sub

'    
Set objWSH = CreateObject("WScript.Shell")
sDBPath = objWSH.RegRead("HKCU\Software\VB and VBA Program Settings\ClientsCount\Settings\Db")

If sDbPath = "" Then
  MsgBox "   !!!", vbError
Else
  sDbFile = Mid(sDBPath, InStrRev(sDBPath, "\") + 1)

  '   ,    
  Set objArgs = WScript.Arguments
  If objArgs.Count = 1 Then 
    sUser = Right(objArgs(0), Len(objArgs(0))-1)
  Else
    On Error Resume Next

    sUser = objWSH.RegRead("HKCU\Software\VB and VBA Program Settings\ClientsCount\Settings\LastUsers")
    If sUser > "" Then
      lIn = InStr(1, sUser, sDbFile & "|")
      If lIn > 0 Then
        sUser = Mid(sUser, lIn + Len(sDbFile & "|"))
        If InStr(1, sUser, "~") > 0 Then
          sUser = Left(sUser, InStr(1, sUser, "~") - 1)
        End If
      End If
    End If
    sUser = InputBox(" ,        Microsoft Outlook", "   Microsoft Outlook", sUser)
  End If

  If Trim(sUser) > "" Then
    '   
    '    ClientsCount

    Set objCon = CreateObject("ADODB.Connection") '  Connection
    objCon.Open "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & sDbPath & ";Persist Security Info=False" '    
    Set objRs = CreateObject("ADODB.Recordset") '  Recordset
    Set objWs = CreateObject("ADODB.Recordset") '  Recordset
    objWs.Open "tblContacts", objCon, 1, 3, 2 ' 1 = adOpenKeyset, 3 = adLockOptimistic, 2 = adCmdTable

    '   Outlook 
    ' - -       CreateObject() 
    ' Symantec Endpoint Protection      Bloodhound.VBS.3
    Dim sObjName
    sObjName="Outlook.Application"
    Set objApp = CreateObject(sObjName) '   Outlook
    Set objContacts = objApp.GetNamespace("MAPI").GetDefaultFolder(10).Items ' 10 = olContactFolder

    '  
    iCntImport = 0 
    iCntExport = 0 
    iCntSync   = 0 
    iCntTotal  = 0 

    '   ClientsCount -> Outlook

    sSql="SELECT * FROM qdfContacts WHERE UserName='" & sUser & "'"
    objRs.Open sSql, objCon
    Do Until objRs.Eof
      Set objItem = objContacts.Find("[FullName]=""" & objRs("Contact").Value & """")
    
      If TypeName(objItem) = "Nothing" Then
        '  
        Set objItem = objApp.CreateItem(2) ' 2 = olContactItem
        objItem.FullName              = objRs("Contact").Value
        objItem.Categories            = " " '   
        ClientsCount2Outlook objRs, objItem
        iCntExport = iCntExport + 1
      Else
        '   
        sMsg = ""
        CheckFields objRs("BirthDate"),  objItem.Birthday
        CheckFields objRs("Title"),      objItem.JobTitle
        CheckFields objRs("Country"),    objItem.BusinessAddressCountry
        CheckFields objRs("City"),       objItem.BusinessAddressCity
        CheckFields objRs("Phone"),      Replace(objItem.MobileTelephoneNumber, " ", "") ' Outlook     
        CheckFields objRs("WorkPhone"),  Replace(objItem.BusinessTelephoneNumber, " ", "")
        CheckFields objRs("EMail"),      objItem.Email1Address
        CheckFields objRs("ICQ"),        objItem.IMAddress
        CheckFields objRs("ClientCalc"), objItem.CompanyName
        If sMsg > "" Then '  
          sMsg = objRs("Contact") & vbcrlf & vbcrlf & "  [ClientsCount]<>[Outlook]" & vbcrlf & "   Outlook ()  ClientsCount () ? " & vbCrLf & sMsg
          If MsgBox(sMsg, vbYesNo) = vbYes Then
            '   Outlook
            ClientsCount2Outlook objRs, objItem
          Else
            '   ClientsCount 
            objWs.Find "[ID] = " & objRs("ID")
            Outlook2ClientsCount objItem, objWs
          End If
          iCntSync = iCntSync + 1
        End If
      End If
      iCntTotal = iCntTotal + 1
      objRs.MoveNext
    Loop
    objRs.Close

   '    Outlook -> ClientsCount
    Dim obj '  Object    For Each
    For Each obj In objContacts
      If (obj.Class = 40) Then ' 40 = olContact
        ' ,     ClientsCount
        sSql = "select * from qdfContacts where UserName='" & sUser & "' and Contact='" & obj.FullName & "'"
        objRs.Open sSql, objCon
        If objRs.EOF Then
          '    ClientsCount
          objWs.AddNew
          objWs("Contact") = obj.FullName
          objWs("UserName") = sUser
          objWs("AddTime") = Now
          Outlook2ClientsCount obj, objWs
          iCntImport = iCntImport + 1
        End If
        objRs.Close
      End If
      iCntOutlook = iCntOutlook + 1
    Next
    objWs.Close
    objCon.Close ' Connection

    '   
    sMsg = "   Microsoft Outlook  ." & vbCrLf & _
      "  Outlook: " & iCntExport & vbCrLf & _
      "  ClientsCount: " & iCntImport & vbCrLf & _
      ": " & iCntSync & vbCrLf & _
      "   ClientsCount: " & iCntTotal & vbCrLf & _
      "   Outlook: " & iCntOutlook
    MsgBox sMsg, vbInformation, ""
  End If
End If

